﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;


/// <summary>
/// User Table Definition
/// </summary>
public class Member_Struct
{
    public Member_Struct()
    {
        //
        // TODO: Add constructor logic here
        //
    }
    long _userid = 0;
    string _username = "";
    string _password = "";
    string _email = "";
    string _countryname = "";
    string _firstname = "";
    string _lastname = "";
    string _gender = "Male";
    DateTime _birthdate = DateTime.Now;
    DateTime _registerdate = DateTime.Now;
    DateTime _last_login = DateTime.Now;
    int _isenabled = 0;

    int _issendmessages = 0;
    int _isallowbirthday = 0;
    int _accounttype = 0;
    int _views = 0;
    string _aboutme = "";
    string _picturename = "";
    string _relationshipstatus = "single";
    string _website = "";
    string _hometown = "";
    string _currentcity = "";
    string _zipcode = "";
    string _occupations = "";
    string _companies = "";
    string _schools = "";
    string _interests = "";
    string _movies = "";
    string _musics = "";
    string _books = "";
    int _videos_watched = 0;
    int _subscribers = 0;

    //user settings
    int _isautomail = 1;
    int _mail_vcomment = 1;
    int _mail_ccomment = 1;
    int _mail_pmessages = 1;
    int _mail_finvite = 1;
    int _mail_subscribe = 1;

    // privacy
    int _privacy_fmessages = 1;

    // extra
    int _video_upload = 0; // no of videos uploaded by user
    int _video_favorited = 0; // no of videos favorited by user
    int _count_comments = 0; // no of user friends
    int _count_friends = 0; // no of user subscribers
    int _count_subscribers = 0; // no of user comments
    int _count_groups = 0; // no of user groups
    int _count_messages = 0; // no of unread user messages
    int _count_photos = 0; // no of photos uploaded by user
    int _count_blogs = 0; // no of blogs uploaded by user
    int _count_audios = 0; // no of upload audio files by user
    int _count_audio_favorites = 0; // no of audio files favorited by user
    int _count_forum_topics = 0; // no of forum topics posted by user
    int _count_forum_points = 0; // no of points awarded to this user

    // channel properties
    int _channel_iscomments = 0;
    int _channel_isfriends = 0;
    int _channel_issubscribers = 0;
    int _channel_isgroups = 0;
    int _channel_isphotos = 0;
    int _channel_isblogs = 0;
    int _channel_isaudios = 0;
    string _channel_name = "";
    string _channel_theme = "";

    int _type = 0; // 0: normal member, 1: administrator, 2: premium users

    // user credits, allocated space and allowed uploads
    int _credits = 0;
    int _remained_video = 0;
    int _remained_audio = 0;
    int _remained_gallery = 0;
    int _remained_photos = 0;
    int _remained_blogs = 0;
    double _space_video = 0;
    double _space_audio = 0;
    double _space_photo = 0;

    DateTime _last_purchased = DateTime.Now;
    DateTime _membership_expiry = DateTime.Now.AddMonths(-4);

    int _islifetimerenewal = 0; // 0: no, 1: yes
    int _roleid = 0;// 0: no role exist

    int _paypal_subscriber = 0;
    string _paypal_email = "";

    int _stat_qa = 0;
    int _stat_qanswers = 0;
    int _stat_qafavorites = 0;

  
    public long UserID
    {
        set { _userid = value; }
        get { return _userid; }
    }

    public string UserName
    {
        set { _username = value; }
        get { return _username; }
    }

    public string Password
    {
        set { _password = value; }
        get { return _password; }
    }

    public string Email
    {
        set { _email = value; }
        get { return _email; }
    }

    public string CountryName
    {
        set { _countryname = value; }
        get { return _countryname; }
    }

    public string FirstName
    {
        set { if (_firstname != "") _firstname = ""; _firstname = value; }
        get { return _firstname; }
    }
    public string LastName
    {
        set { if (_lastname != "") _lastname = ""; _lastname = value; }
        get { return _lastname; }
    }

    public DateTime RegisterDate
    {
        set { _registerdate = value; }
        get { return _registerdate; }
    }

    public int isEnabled
    {
        set { _isenabled = value; }
        get { return _isenabled; }
    }

    public int AccountType
    {
        set { _accounttype = value; }
        get { return _accounttype; }
    }

    public int Views
    {
        set { _views = value; }
        get { return _views; }
    }

    public string PictureName
    {
        set { _picturename = value; }
        get { return _picturename; }
    }

    public string Gender
    {
        set { _gender = value; }
        get { return _gender; }
    }

    public DateTime BirthDate
    {
        set { _birthdate = value; }
        get { return _birthdate; }
    }

    public int isAutoMail
    {
        set { _isautomail = value; }
        get { return _isautomail; }
    }

    public int isAllowBirthDay
    {
        set { _isallowbirthday = value; }
        get { return _isallowbirthday; }
    }

    public int isSendMessages
    {
        set { _issendmessages = value; }
        get { return _issendmessages; }
    }

    public string RelationshipStatus
    {
        set { _relationshipstatus = value; }
        get { return _relationshipstatus; }
    }

    public string Website
    {
        set { _website = value; }
        get { return _website; }
    }

    public string HometTown
    {
        set { _hometown = value; }
        get { return _hometown; }
    }

    public string CurrentCity
    {
        set { _currentcity = value; }
        get { return _currentcity; }
    }

    public string Zipcode
    {
        set { _zipcode = value; }
        get { return _zipcode; }
    }

    public string Occupations
    {
        set { _occupations = value; }
        get { return _occupations; }
    }

    public string Companies
    {
        set { _companies = value; }
        get { return _companies; }
    }

    public string Schools
    {
        set { _schools = value; }
        get { return _schools; }
    }

    public string Interests
    {
        set { _interests = value; }
        get { return _interests; }
    }

    public string Movies
    {
        set { _movies = value; }
        get { return _movies; }
    }

    public string Musics
    {
        set { _musics = value; }
        get { return _musics; }
    }

    public string Books
    {
        set { _books = value; }
        get { return _books; }
    }


    public string AboutMe
    {
        set { _aboutme = value; }
        get { return _aboutme; }
    }

    public int Mail_VComment
    {
        set { _mail_vcomment = value; }
        get { return _mail_vcomment; }
    }

    public int Mail_CComment
    {
        set { _mail_ccomment = value; }
        get { return _mail_ccomment; }
    }

    public int Mail_PMessage
    {
        set { _mail_pmessages = value; }
        get { return _mail_pmessages; }
    }

    public int Mail_FInvite
    {
        set { _mail_finvite = value; }
        get { return _mail_finvite; }
    }

    public int Mail_Subscribe
    {
        set { _mail_subscribe = value; }
        get { return _mail_subscribe; }
    }

    public int Privacy_FMessages
    {
        set { _privacy_fmessages = value; }
        get { return _privacy_fmessages; }
    }

    public int Videos_Watched
    {
        set { _videos_watched = value; }
        get { return _videos_watched; }
    }

    public int Subscribers
    {
        set { _subscribers = value; }
        get { return _subscribers; }
    }

    public DateTime Last_Login
    {
        set { _last_login = value; }
        get { return _last_login; }
    }

    public int Video_Upload
    {
        set { _video_upload = value; }
        get { return _video_upload; }
    }

    public int Video_Favorited
    {
        set { _video_favorited = value; }
        get { return _video_favorited; }
    }

    public int Count_Comments
    {
        set { _count_comments = value; }
        get { return _count_comments; }
    }

    public int Count_Friends
    {
        set { _count_friends = value; }
        get { return _count_friends; }
    }

    public int Count_Subscribers
    {
        set { _count_subscribers = value; }
        get { return _count_subscribers; }
    }

    public int Count_Groups
    {
        set { _count_groups = value; }
        get { return _count_groups; }
    }

    public int Count_Messages
    {
        set { _count_messages = value; }
        get { return _count_messages; }
    }

    public int Count_Photos
    {
        set { _count_photos = value; }
        get { return _count_photos; }
    }

    public int Count_Blogs
    {
        set { _count_blogs = value; }
        get { return _count_blogs; }
    }

    public int Count_Audios
    {
        set { _count_audios = value; }
        get { return _count_audios; }
    }

    public int Count_Audio_Favorites
    {
        set { _count_audio_favorites = value; }
        get { return _count_audio_favorites; }
    }

    public int Count_Forum_Topics
    {
        set { _count_forum_topics = value; }
        get { return _count_forum_topics; }
    }

    public int Count_Forum_Points
    {
        set { _count_forum_points = value; }
        get { return _count_forum_points; }
    }


    public int Channel_isAudios
    {
        set { _channel_isaudios = value; }
        get { return _channel_isaudios; }
    }

    public int Channel_isComments
    {
        set { _channel_iscomments = value; }
        get { return _channel_iscomments; }
    }

    public int Channel_isFriends
    {
        set { _channel_isfriends = value; }
        get { return _channel_isfriends; }
    }

    public int Channel_isSubscribers
    {
        set { _channel_issubscribers = value; }
        get { return _channel_issubscribers; }
    }

    public int Channel_isGroups
    {
        set { _channel_isgroups = value; }
        get { return _channel_isgroups; }
    }

    public int Channel_isPhotos
    {
        set { _channel_isphotos = value; }
        get { return _channel_isphotos; }
    }

    public int Channel_isBlogs
    {
        set { _channel_isblogs = value; }
        get { return _channel_isblogs; }
    }


    public string Channel_Name
    {
        set { _channel_name = value; }
        get { return _channel_name; }
    }

    public string Channel_Theme
    {
        set { _channel_theme = value; }
        get { return _channel_theme; }
    }

    public int Type
    {
        set { _type = value; }
        get { return _type; }
    }

    // credits, allocated space and services 
    public int Credits
    {
        set { _credits = value; }
        get { return _credits; }
    }

    public int Remained_Video
    {
        set { _remained_video = value; }
        get { return _remained_video; }
    }

    public int Remained_Audio
    {
        set { _remained_audio = value; }
        get { return _remained_audio; }
    }

    public int Remained_Gallery
    {
        set { _remained_gallery = value; }
        get { return _remained_gallery; }
    }

    public int Remained_Photos
    {
        set { _remained_photos = value; }
        get { return _remained_photos; }
    }

    public int Remained_Blogs
    {
        set { _remained_blogs = value; }
        get { return _remained_blogs; }
    }

    public double Space_Video
    {
        set { _space_video = value; }
        get { return _space_video; }
    }

    public double Space_Audio
    {
        set { _space_audio = value; }
        get { return _space_audio; }
    }

    public double Space_Photo
    {
        set { _space_photo = value; }
        get { return _space_photo; }
    }

    public int RoleID
    {
        set { _roleid = value; }
        get { return _roleid; }
    }

    public DateTime Last_Purchased
    {
        set { _last_purchased = value; }
        get { return _last_purchased; }
    }
    public DateTime Membership_Expiry
    {
        set { _membership_expiry = value; }
        get { return _membership_expiry; }
    }

    public int isLifeTimeRenewal
    {
        set { _islifetimerenewal = value; }
        get { return _islifetimerenewal; }
    }
   
    public int Paypal_Subscriber
    {
        set { _paypal_subscriber = value; }
        get { return _paypal_subscriber; }
    }

    public string Paypal_Email
    {
        set { _paypal_email = value; }
        get { return _paypal_email; }
    }

    public int Stat_QA
    {
        set { _stat_qa = value; }
        get { return _stat_qa; }
    }
    public int Stat_QAnswers
    {
        set { _stat_qanswers = value; }
        get { return _stat_qanswers; }
    }
    public int Stat_QFavorites
    {
        set { _stat_qafavorites = value; }
        get { return _stat_qafavorites; }
    }
}
