using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Globalization;
using System.Threading;

public partial class _Default : System.Web.UI.Page
{    
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {       
            if (Config.isVideos())
            {
                if (vd_sm1 != null)
                {
                    // featured videos
                    vd_sm1.HeadingTitle = "Featured Videos";
                    vd_sm1.NoRecordFoundText = "No featured videos found!";
                    vd_sm1.See_All_Url_Tooltip = "Browse all featured videos";
                    vd_sm1.EnableNavigation = false;
                    vd_sm1.EnableAnimation = false; // disable slide animation
                    vd_sm1.EnableDateFilterNavigation = false;
                    vd_sm1.TotalColumns = 2; // total number of videos to display
                    vd_sm1.Records = 4;
                    vd_sm1.Order = "v.date_added desc,v.liked desc, v.views desc";
                    vd_sm1.isCache = true; // cache records for specified time interval
                    vd_sm1.isfeatured = 1;

                    vd_sm1.ShowDate = false;
                    vd_sm1.ShowTitle = false;
                    vd_sm1.ShowUser = false;
                }
               
             
                if (vd_sm2 != null)
                {
                    // recent videos
                    vd_sm2.HeadingTitle = Resources.vsk.recent + " " + Resources.vsk.videos;
                    vd_sm2.NoRecordFoundText = Resources.vsk.novideosuploadedyet;
                    vd_sm2.See_All_Url_Tooltip = Resources.vsk.browseallvideos;

                    vd_sm2.NavigationLinks = new string[] { Resources.vsk.recent, Resources.vsk.viewed, Resources.vsk.liked, Resources.vsk.favorites, Resources.vsk.comments };
                    vd_sm2.NavigationLinkOrderFields = new string[] { "v.date_added desc", "v.views desc", "v.liked desc", "v.favorites desc", "v.comments desc" };
                    vd_sm2.EnableNavigation = true;
                    vd_sm2.EnableAnimation = true; // disable slide animation
                    vd_sm2.EnableDateFilterNavigation = true;
                    vd_sm2.NavigationCssClass = "nav nav-tabs"; // css class to effect main ul / li listings
                    vd_sm2.NavigationActiveLinkCssClass = "active";
                    vd_sm2.DateFilterNavigationCssClass = "item_pad_2_r bx_br_both hor_lst"; // apply css on date filter navigation div
                    vd_sm2.DateFilterLinkCssClass = "";
                    vd_sm2.DateFilterActiveLinkCssClass = "normal-text reverse";
                    vd_sm2.TotalColumns = 4; // total number of videos to display

                    vd_sm2.Records = 16;
                    vd_sm2.Order = "v.date_added desc,v.isfeatured desc,v.liked desc, v.views desc";

                    vd_sm2.isCache = true; // cache records for specified time interval
                }
            }
            else
            {               
                vd.Visible = false;
            }

            // set meta information
            HtmlHead head = (HtmlHead)Page.Header;
            string meta_title = "ASP.NET Youtube Clone"; // Resources.vsk.meta_home_title;
            string meta_description = "ASP.NET Youtube Clone script allow you to build feature rich sociam media solution just like youtube in asp.net, c# easily.";

            MetaTagsBLL.META_StaticPage(this.Page, head,meta_title,meta_description, UrlConfig.Return_Website_Logo_Url(), Config.GetUrl());
        }
   
    }
}