﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Collections.Generic;


public partial class adm_sc_tags_Default : System.Web.UI.Page
{
    public int PageNumber
    {
        get
        {
            if (ViewState["PageNumber"] != null)
                return (int)ViewState["PageNumber"];
            else
                return 1;
        }
        set
        {
            ViewState["PageNumber"] = value;
        }
    }

    public string Status
    {
        get
        {
            if (ViewState["Status"] != null)
                return ViewState["Status"].ToString();
            else
                return "all";
        }
        set
        {
            ViewState["Status"] = value;
        }
    }


    public int TotalRecords
    {
        get
        {
            if (ViewState["TotalRecords"] != null)
                return (int)ViewState["TotalRecords"];
            else
                return 0;
        }
        set
        {
            ViewState["TotalRecords"] = value;
        }
    }

    protected override void OnInit(EventArgs e)
    {
        base.OnInit(e);
        rptPages.ItemCommand += this.rptPages_ItemCommand;
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            // Toggle on | of features
            Toggle_Dropdown_List(drp_filter);

            //// check whether tags already exist
            //int cnt_tags = TagsBLL.Count_Tags();
            //if (cnt_tags == 0)
            //{
            //    // process old tags
            //    TagsBLL.Process_Old_Tags();
            //}
            if (Request.Params["t"] != null)
                drp_filter.SelectedValue = Request.Params["t"].ToString();
            if (Request.Params["e"] != null)
                this.Status = Request.Params["e"].ToString();
            BindList();
        }
    }

    protected void drp_filter_SelectedIndexChanged(object sender, System.EventArgs e)
    {
        // load category detail list
        BindList();
    }

    private void BindList()
    {
        if (this.TotalRecords == 0)
            this.TotalRecords = TagsBLL.Count_Admin_Tags(txt_search.Text,drp_level.SelectedValue.ToString(),Convert.ToInt32(drp_filter.SelectedValue),this.Status,drp_tagtype.SelectedValue);

        if (this.TotalRecords == 0)
        {
            // no record exist
            pnl_main.Visible = false;
            pnl_norecord.Visible = true;
            return;
        }

        List<Tags_Struct> list = TagsBLL.Load_Admin_V2(txt_search.Text, drp_level.SelectedValue.ToString(), Convert.ToInt32(drp_filter.SelectedValue), this.Status, drp_tagtype.SelectedValue, Convert.ToInt32(drp_order.SelectedValue), this.PageNumber, 100);
        if (list.Count > 0)
        {
            Pagination_Process.Process_Pagination(MyList, rptPages, lnk_Prev, lnk_Next, 100, this.PageNumber, list, this.TotalRecords);
            pnl_main.Visible = true;
            pnl_norecord.Visible = false;
        }
        else
        {
            pnl_main.Visible = false;
            pnl_norecord.Visible = true;
        }
    }
    
    protected void lnk_Next_Click(object sender, EventArgs e)
    {
        PageNumber = PageNumber + 1;
        BindList();
    }

    protected void lnk_Prev_Click(object sender, EventArgs e)
    {
        PageNumber = PageNumber - 1;
        BindList();
    }

    protected void rptPages_ItemCommand(object source, RepeaterCommandEventArgs e)
    {
        LinkButton btnPage = (LinkButton)e.Item.FindControl("btnPage");
        PageNumber = int.Parse(btnPage.Text);
        BindList();
    }

    protected void rptPages_ItemDataBound(object sender, RepeaterItemEventArgs e)
    {
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
        {
            LinkButton btnPage = (LinkButton)e.Item.FindControl("btnPage");
            if (int.Parse(btnPage.Text) == PageNumber)
            {
                btnPage.CssClass = "btn btn-danger btn-mini";
            }
            else
            {
                btnPage.CssClass = "btn btn-primary btn-mini";
            }
        }
    }
    
    protected void MyList_EditCommand(object source, DataListCommandEventArgs e)
    {
        string cmd = ((LinkButton)e.CommandSource).CommandName;
        if (cmd == "Edit")
            ((DataList)source).EditItemIndex = e.Item.ItemIndex;

        BindList();
    }

    protected void MyList_DeleteCommand(object source, DataListCommandEventArgs e)
    {
        // Check whether admin section is in readonly mode.
        if (!Config.isAdminActionAllowed())
        {
            Response.Redirect( Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
            return;
        }
        Label lbl_tagid = (Label)e.Item.FindControl("lbl_tagid");
        int tagid = int.Parse(lbl_tagid.Text);

        TagsBLL.Delete(tagid);
        Config.ShowMessageV2(msg, "Tag Deleted Successfully", "Success!", 1);
        BindList();
    }

    protected void MyList_UpdateCommand(object source, DataListCommandEventArgs e)
    {
        // Check whether admin section is in readonly mode.
        if (!Config.isAdminActionAllowed())
        {
            Response.Redirect( Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
            return;
        }
        Label lbl_tagid = (Label)e.Item.FindControl("lbl_tagid");
        int tagid = int.Parse(lbl_tagid.Text);
        TextBox txt_tagname = (TextBox)e.Item.FindControl("txt_tagname");
        int periority = int.Parse(((TextBox)e.Item.FindControl("txt_periority")).Text);
        int tag_level = int.Parse(((DropDownList)e.Item.FindControl("drp_level")).SelectedValue);

        TagsBLL.Update_Tag_Status(tagid, txt_tagname.Text, 1, tag_level, periority);
        Config.ShowMessageV2(msg, "Tag updated and activated Successfully", "Success!", 1);
        MyList.EditItemIndex = -1;
        BindList();
    }

    protected void MyList_ItemDataBound(object sender, DataListItemEventArgs e)
    {
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
        {
            Label lbl_tagstatus = (Label)e.Item.FindControl("lbl_tagstatus");
            Label lbl_taglevel = (Label)e.Item.FindControl("lbl_taglevel");
            int status = int.Parse(lbl_tagstatus.Text);
            if (status == 0)
            {
                lbl_tagstatus.Text = "Deactivated";
            }
            else
            {
                lbl_tagstatus.Text = "Activated";
                lbl_tagstatus.CssClass = "red_text_bold";
            }
            int level = int.Parse(lbl_taglevel.Text);
            switch (level)
            {
                case 0:
                    lbl_taglevel.Text = "High";
                    break;
                case 1:
                    lbl_taglevel.Text = "Medium";
                    break;
                case 2:
                    lbl_taglevel.Text = "Low";
                    break;
                case 3:
                    lbl_taglevel.Text = "Topic";
                    lbl_taglevel.CssClass = "mini-text green bold";
                    break;
                case 4:
                    lbl_taglevel.Text = "Profile";
                    lbl_taglevel.CssClass = "mini-text red bold";
                    break;
                case 5:
                    lbl_taglevel.Text = "Both";
                    lbl_taglevel.CssClass = "gold_style";
                    break;
            }
        }
        if (e.Item.ItemType == ListItemType.EditItem)
        {
            string taglevel = ((Label)e.Item.FindControl("lbl_taglevel")).Text;
            DropDownList drp_level = (DropDownList)e.Item.FindControl("drp_level");
            drp_level.SelectedValue = taglevel;
        }
    }
    
    protected void btn_delete_Click(object sender, EventArgs e)
    {
        // Check whether admin section is in readonly mode.
        if (!Config.isAdminActionAllowed())
        {
            Response.Redirect( Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
            return;
        }
        int index;
        bool flg = false;
        for (index = 0; index < MyList.Items.Count; index++)
        {
            CheckBox select_chk;
            select_chk = (CheckBox)MyList.Items[index].FindControl("chk_inbox");
            if (select_chk.Checked)
            {
                int tagid = int.Parse(((Label)MyList.Items[index].FindControl("lbl_tagid")).Text);
                TagsBLL.Delete(tagid);

                if (flg == false)
                    flg = true;

            }

        }
        if (flg == false)
            Config.ShowMessageV2(msg, "Please select a record.", "Info!", 2);
        else
            Config.ShowMessageV2(msg, "Selected records have been deleted successfully.", "Success!", 1);

        BindList();
    }

    protected void drp_level_SelectedIndexChanged(object sender, EventArgs e)
    {
        this.PageNumber = 1;
        BindList();
    }

    protected void drp_tagtype_SelectedIndexChanged(object sender, EventArgs e)
    {
        this.PageNumber = 1;
        BindList();
    }

    protected void MyList_CancelCommand(object source, DataListCommandEventArgs e)
    {
        MyList.EditItemIndex = -1;
        BindList();
    }
    protected void btn_high_Click(object sender, EventArgs e)
    {
        UpdateTagLevel(0);
    }
    protected void btn_medium_Click(object sender, EventArgs e)
    {
        UpdateTagLevel(1);
    }
    protected void btn_low_Click(object sender, EventArgs e)
    {
        UpdateTagLevel(2);
    }
      

    private void UpdateTagLevel(int level)
    {
        // Check whether admin section is in readonly mode.
        if (!Config.isAdminActionAllowed())
        {
            Response.Redirect( Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
            return;
        }
        int index;
        bool flg = false;
        for (index = 0; index < MyList.Items.Count; index++)
        {
            CheckBox select_chk;
            select_chk = (CheckBox)MyList.Items[index].FindControl("chk_inbox");
            if (select_chk.Checked)
            {
                int tagid = int.Parse(((Label)MyList.Items[index].FindControl("lbl_tagid")).Text);
                TagsBLL.Update_Tag_Level(tagid, 1, level);
                if (flg == false)
                    flg = true;

            }

        }
        if (flg == false)
            Config.ShowMessageV2(msg, "Please select a record.", "Info!", 2);
        else
            Config.ShowMessageV2(msg, "Selected records have been updated successfully.", "Success!", 1);

        BindList();
    }

    protected void drp_order_SelectedIndexChanged(object sender, EventArgs e)
    {
        BindList();
    }

    // Toggle on | off features
    private void Toggle_Dropdown_List(DropDownList drp)
    {      

     
    }


    protected void btn_search_Click(object sender, EventArgs e)
    {
        this.PageNumber = 1;
        BindList();
    }

    protected void btn_dall_Click(object sender, EventArgs e)
    {
        TagsBLL.Delete_Inactive();
        Config.ShowMessageV2(msg, "All inactive tags have been deleted successfully.", "Success!", 1);
    }
    protected void btn_b_dall_Click(object sender, EventArgs e)
    {
        TagsBLL.Delete_Inactive();
        Config.ShowMessageV2(msg, "All inactive tags have been deleted successfully.", "Success!", 1);
    }

    protected void btn_active_Click(object sender, EventArgs e)
    {
        Activate_All();
    }
    protected void btn_ball_Click(object sender, EventArgs e)
    {
        Activate_All();
    }

    private void Activate_All()
    {
        TagsBLL.Activate_All_Tags(Convert.ToInt32(drp_filter.SelectedValue));
        Config.ShowMessageV2(msg, "All inactive tags have been activated successfully.", "Success!", 1);
    }

    
}
