﻿<%@ WebHandler Language="C#" Class="like" %>

using System;
using System.Web;
using System.Collections.Generic;
using System.Text;

public class like : IHttpHandler {
    // This handle used to post rating (like | dislike) for any item
    private int Type = 0; // 0: video, audio, 1: comment adv points, 2: photo rating , 3: blog rating
    private int MediaType = 0; // 0: video, 1: audio
    private long ContentID = 0;
    private string UserName = "";
    private int Liked = 0;
    private int Disliked = 0;
    private int Action = 0; // 0: Liked, 1: Disliked
    private string Message = "";
    private string ElementID = ""; // div id where to load content
    public int RatingType = 0; // 0: like / dislike, 1: start rating
    public double Avg_Ratings = 0; 
    public double Ratings = 0;
    public int TotalRatings = 0;
     
    public void ProcessRequest (HttpContext context) {
        context.Response.ContentType = "text/plain";
        //*********************************
        // Security Check
        //*********************************
        if (context.Request.UrlReferrer == null)
        {
            context.Response.Write("p400"); // Authorization Failed"
        }
        else
        {
            if (context.Request.Params["t"] != null)
                this.Type = Convert.ToInt32(context.Request.Params["t"]);
            if (context.Request.Params["mtp"] != null)
                this.MediaType = Convert.ToInt32(context.Request.Params["mtp"]);
            if (context.Request.Params["id"] != null)
                this.ContentID = Convert.ToInt64(context.Request.Params["id"]);
            if (context.Request.Params["usr"] != null)
                this.UserName = context.Request.Params["usr"].ToString();
            if (context.Request.Params["lk"] != null)
                this.Liked = Convert.ToInt32(context.Request.Params["lk"]);
            if (context.Request.Params["dlk"] != null)
                this.Disliked = Convert.ToInt32(context.Request.Params["dlk"]);
            if (context.Request.Params["act"] != null)
                this.Action = Convert.ToInt32(context.Request.Params["act"]);
            if (context.Request.Params["elid"] != null)
                this.ElementID = context.Request.Params["elid"].ToString();
            if (context.Request.Params["rtype"] != null)
                this.RatingType = Convert.ToInt32(context.Request.Params["rtype"]);
            if (context.Request.Params["ratings"] != null)
                this.Ratings = Convert.ToDouble(context.Request.Params["ratings"]);
            if (context.Request.Params["aratings"] != null)
                this.Avg_Ratings = Convert.ToDouble(context.Request.Params["aratings"]);
            if (context.Request.Params["tratings"] != null)
                this.TotalRatings = Convert.ToInt32(context.Request.Params["tratings"]);
       

            // if user already logged in
            if (this.UserName != "")
            {                
                // check whether he / she already post rating on same content
                if (!User_Ratings.Check(this.UserName, this.ContentID, this.Type))
                {
                    // proceed user to post vote
                    if (this.RatingType == 0)
                    {
                        // like / dislike
                        Post_Vote();
                    }
                    else
                    {
                        // normal ratings
                        Post_Rating();
                    }
                    
                    // add user statistics
                    User_Ratings.Add(this.UserName, this.ContentID, this.Type, this.Action); //rating 0: liked, 1: disliked
                    if (this.RatingType == 0)
                        this.Message = Set_Liked_Message();
                    else
                        this.Message = Set_Rating_Message();
                }
                else
                {
                    // he already post their vote
                    if (this.RatingType == 0)
                        this.Message = Set_Liked_Message();
                    else
                        this.Message = Set_Rating_Message();
                }
            }
            else
            {
                if (Site_Settings.Feature_Login_Rating == 0)
                {
                    // directly post vote without storing user statistics
                    if (this.RatingType == 0)
                    {
                        Post_Vote();
                        this.Message = Set_Liked_Message();
                    }
                    else
                    {
                        Post_Rating();
                        this.Message = Set_Rating_Message();
                    }
                }
            }

            context.Response.Write(this.Message);
        }
    }
 
    public bool IsReusable {
        get {
            return false;
        }
    }

    // like | dislike
    private void Post_Vote()
    {
        if (this.Action == 0)
        {
            this.Liked = this.Liked + 1;
            switch (this.Type)
            {
                case 0:
                    VideoBLL.Update_Field(this.ContentID, this.Liked.ToString(), "liked");
                    break;
             
            }
            this.Liked = this.Liked + 1;
        }
        else
        {
            this.Disliked = this.Disliked + 1;
            switch (this.Type)
            {
                case 0:
                    VideoBLL.Update_Field(this.ContentID, this.Disliked.ToString(), "disliked");
                    break;
            
            }
            this.Disliked = this.Disliked + 1;
        }
    }

    // normal ratings
    private void Post_Rating()
    {
        if (this.Action > 5)
            this.Action = 5;

        switch (this.Type)
        {
            case 0:
                this.Avg_Ratings = VideoBLL.Post_Rating(this.ContentID, this.Action, this.TotalRatings, this.Ratings);
                break;
          
            case 3:
                // currently not supported in blogs
                break;
            case 9:
               // currently not supported in galleries
                break;
        }
        this.TotalRatings = this.TotalRatings + 1;
        this.Ratings = this.Ratings + 1;
    }

    // set liked | disliked Message
    private string Set_Liked_Message()
    {
        string action = "liked";
        if (this.Action != 0)
            action = "disliked";
        
        string content_type = "";
        string content_url = "";
        switch (this.Type)
        {
            case 0:
                // video | audio
                if (this.MediaType == 1)
                {
                    // audio
                    content_url = "<a href=\"" + Config.GetUrl() + "myaccount/audio/My_Liked_Audio.aspx\">audio files you " + action + "</a>";
                    content_type = "audio file";
                }
                else
                {
                    // video
                    content_url = "<a href=\"" + Config.GetUrl() + "myaccount/My_Liked_Videos.aspx\">videos you " + action + "</a>";
                    content_type = "video";
                }
                break;
            case 2:
                content_url = "<a href=\"" + Config.GetUrl() + "myaccount/photos/My_Liked_Photos.aspx\">photos you " + action + "</a>";
                content_type = "photo";
                break;
            case 3:
                content_url = "<a href=\"" + Config.GetUrl() + "myaccount/blogs/My_Liked_Blogs.aspx\">blogs you " + action + "</a>";
                content_type = "blog post";
                break;
            case 9:
                // no gallery feature available - redirect user to photos
                content_url = "<a href=\"" + Config.GetUrl() + "myaccount/photos/My_Liked_Photos.aspx\">photo galleries you " + action + "</a>";
                content_type = "gallery";
                break;

        }
        //**********************************************************
        // Generate Output Panel
        //**********************************************************
        int total_votes = this.Liked + this.Disliked;
        StringBuilder str = new StringBuilder();
        str.Append("<div class=\"bx_br_bt\" style=\"padding-bottom:5px;\">You " + action + " this " + content_type + ". Thanks for the feedback!");
        if (this.UserName != "") // if user logged in
            str.Append(" See more " + content_url + ".");
        str.Append("</div>");
        str.Append("<div class=\"bx_br_bt\" style=\"padding:5px 0px;\"><strong>Rating for this " + content_type + " </strong><span class=\"normal-text reverse\">(" + total_votes + " total)</span>");
        str.Append("<div class=\"clear\"></div>\n");
        // internal rating section
        str.Append("<div class=\"item_pad_4\" style=\"width:300px;\">\n");
        str.Append(Generate_Rating_Bx());
        str.Append("</div>\n");
        str.Append("</div>");

        return Config.SetHiddenMessage_v2(str.ToString(), this.ElementID, true, 4);
      
    }

    // Generate Rating Message
    private string Set_Rating_Message()
    {
        string action = "rated";
        string content_type = "";
        string content_url = "";
        switch (this.Type)
        {
            case 0:
                // video | audio
                if (this.MediaType == 1)
                {
                    // audio
                    content_url = "<a href=\"" + Config.GetUrl() + "myaccount/audio/My_Liked_Audio.aspx\">audio files you " + action + "</a>";
                    content_type = "audio file";
                }
                else
                {
                    // video
                    content_url = "<a href=\"" + Config.GetUrl() + "myaccount/My_Liked_Videos.aspx\">videos you " + action + "</a>";
                    content_type = "video";
                }
                break;
            case 2:
                content_url = "<a href=\"" + Config.GetUrl() + "myaccount/photos/My_Liked_Photos.aspx\">photos you " + action + "</a>";
                content_type = "photo";
                break;
            case 3:
                content_url = "<a href=\"" + Config.GetUrl() + "myaccount/blogs/My_Liked_Blogs.aspx\">blogs you " + action + "</a>";
                content_type = "blog post";
                break;
            case 9:
                // currently not supported
                // no gallery feature available - redirect user to photos
                content_url = "<a href=\"" + Config.GetUrl() + "myaccount/photos/My_Liked_Photos.aspx\">photo galleries you " + action + "</a>";
                content_type = "gallery";
                break;

        }
        //**********************************************************
        // Generate Output Panel
        //**********************************************************
        int total_votes = this.Liked + this.Disliked;
        StringBuilder str = new StringBuilder();
        str.Append("<div class=\"bx_br_bt\" style=\"padding-bottom:5px;\">You " + action + " this " + content_type + ". Thanks for the rating feedback!");
        if (this.UserName != "") // if user logged in
            str.Append(" See more " + content_url + ".");
        str.Append("</div>");
        str.Append("<div class=\"bx_br_bt\" style=\"padding:5px 0px;\"><strong>Rating for this " + content_type + " </strong><span class=\"normal-text reverse\">(" + this.TotalRatings + " total, " + this.Avg_Ratings + " out of 5)</span>");
        str.Append("<div class=\"clear\"></div>\n");
        // internal rating section
        str.Append("<div class=\"item_pad_4\">\n");
        str.Append("<ul class='star-rating'>\n");
        str.Append("<li class='current-rating' style=\"width:" + Calculate_Ratings() + "px;\">Currently " + Math.Round(this.Avg_Ratings, 2) + "/5 Stars.</li>\n");
        str.Append("<li><a href='#' title='1 star out of 5' class='one-star'>1</a></li>\n");
        str.Append("<li><a href='#' title='2 stars out of 5' class='two-stars'>2</a></li>\n");
        str.Append("<li><a href='#' title='3 stars out of 5' class='three-stars'>3</a></li>\n");
        str.Append("<li><a href='#' title='4 stars out of 5' class='four-stars'>4</a></li>\n");
        str.Append("<li><a href='#' title='5 stars out of 5' class='five-stars'>5</a></li>\n");
        str.Append("</ul>\n"); 
        str.Append("</div>\n");
        str.Append("</div>");

        return Config.SetHiddenMessage_v2(str.ToString(), this.ElementID, true,4);

    }

    private string Generate_Rating_Bx()
    {
        StringBuilder str = new StringBuilder();
        int total_liked = this.Liked + this.Disliked;
        double liked_percentage = (double)(this.Liked * 100) / total_liked;
        double disliked_percentage = (double)(this.Disliked * 100) / total_liked;
        if (liked_percentage > 0 || disliked_percentage > 0)
        {
            if (liked_percentage > 98)
            {
                str.Append("<div id=\"like_rating\" style=\"width: 100%;\" class=\"bx_like\"></div>\n");
            }
            else if (disliked_percentage > 98)
            {
                str.Append("<div id=\"dislike_rating\" style=\"width: 100%;\" class=\"bx_dislike\"></div>\n");
            }
            else
            {
                disliked_percentage = 100 - liked_percentage; // 7 for creating gap between two meters.
                // liked meter
                str.Append("<div class=\"item_pad_2\">\n");
                str.Append("<div id=\"like_rating\" style=\"width: " + Convert.ToInt32(liked_percentage).ToString() + "%;\" class=\"bx_like\"></div>\n");
                str.Append("</div>");
                str.Append("<div class=\"item_pad_2\">\n");
                str.Append("<div id=\"dislike_rating\" style=\"width: " + Convert.ToInt32(disliked_percentage).ToString() + "%;\" class=\"bx_dislike\"></div>\n");
                str.Append("</div>");
                str.Append("<div class=\"clear\"></div>\n");
            
            }
        }
        else
        {
            // no liked or disliked yet
            // show full rating
            str.Append("<div id=\"like_rating\" style=\"width: 100%;\" class=\"bx_like\"></div>\n");
        }
      
        return str.ToString();
    }
    
    private int Calculate_Ratings()
    {
        return (int)this.Avg_Ratings * 24; // 24x24 each rating size
    }
}