﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;

using System.Collections.Generic;
using System.Text;

public partial class modules_tags : System.Web.UI.UserControl
{
    // CSS Properties
    public string URL = "";
    public int BoxTemplate = 0; // Default,
    public string BoxCssClass = ""; // main box css style
    public string HeadingCssClass = ""; // main box heading css style
    public string BodyCssClass = ""; // main body section css style
    public string CssClass = ""; // Provide link css class
    public string ActiveCssClass = "xmedium-text bold"; // provide active link css class
    public string ListingCssClass = "flow_lst"; // "flow_lst" // ver_lst
    // tag listing properties

    public string Term = ""; // filter tags based on selected category.
    public bool isHeading = true; // Enable / Disable Heading
    public string HeadingTitle = "";
    public bool MultiColumn = false;
    public int TotalColumns = 2; // Display records in n level of columns
    public int Type = 0; // 0: videos, 1: groups, 2: photos, 3: blogs, 4: audio files, 5: general, 6: galleries, 7: forums, 100: all
    public int Tag_Type = 0; // 0: normal tags, 1: search tags, 2: all tags
    public int Tag_Level = 100; // 0: high, 1: medium, 2: low, 100: all
    public int isEnabled = 1; // 0: disabled, 1: enabled, 2: all
    public int Records = 20;
    public string Order = "tagid desc";
    public bool isAll = false;
    public bool MainProfileTag = false;
    public bool isCache = true;
    // More Link Urls
    public string MoreLinkUrl = "";
    public string MoreLinkText = Resources.vsk.seeall;
    public string LinkToolTip = "";
    public string MoreLinkToolTip = "";
    // Load all tags
    public bool EnablePagination = false; // enable pagination in case of loading all tags.
    public int TotalRecords = 0; // total records available
    public string PageDescription = ""; // set meta page description
    public string NoRecordFoundText = "No Tags Found";
    // pagination url
    public string DefaultUrl = "";
    public string Pagination_Url = "";
    private int _pagenumber = 1;
    private int PageNumber
    {
        get
        {
            if (Request.Params["p"] != null)
                return Convert.ToInt32(Request.Params["p"]);
            else
                return _pagenumber;
        }
    }

    // advance ajax navigation
    public bool EnableNavigation = false; // enable top navigation (recent, viewed, liked, favorited etc)
    public string NavigationCssClass = "nav nav-tabs";
    public string NavigationLinkCssClass = "";
    public string NavigationActiveLinkCssClass = "normal-text reverse";
    public int NavigationActiveTab = 0; // 0: Recent, 1: View, 2: Like, 3: Favorite, 4: Comment
    public bool EnableAnimation = true; // Slide show animation when ajax event is called
    public string[] NavigationLinks = new string[] { Resources.vsk.videos, Resources.vsk.audio, Resources.vsk.photos, Resources.vsk.blogs, Resources.vsk.galleries };
    public string[] NavigationLinkOrderFields = new string[] { "0", "4", "2", "3", "6" };
    string handler_path = Config.GetUrl("handlers/nav/tags.ashx");

    protected void Page_PreRender(object sender, EventArgs e)
    {
        // Toggle on | off tags
        pg.Visible = false;
        if (!Config.isFeature_Tags())
        {
            widget.Visible = false;
            return;
        }

        if (this.BoxCssClass == "")
            PrepareBoxTemplates();

        widget.Attributes.Add("class", this.BoxCssClass + " " + this.ListingCssClass); // add css class to widget item

        if (!Page.IsPostBack)
        {
            BindList();
        }
    }

    private void BindList()
    {
        // generate tag listings
        StringBuilder str = new StringBuilder();
        if (this.isHeading)
        {
            hd.Attributes.Add("class", HeadingCssClass);
            htitle.InnerHtml = this.HeadingTitle;
        }
        // generate top navigation if enabled
        if (this.EnableNavigation)
        {
            str.Append(Generate_Top_Navigation());
        }
        // gallery / photo have same loading type = 5
        int _type = this.Type;
        if (_type == 6)
            _type = 2;

        if (this.EnablePagination)
        {
            this.TotalRecords = TagsBLL.CountRecentTags_V2(this.Term, _type, this.Tag_Type, this.Tag_Level, this.isEnabled);
            if (this.TotalRecords == 0)
            {
                // no records found
                str.Append("<div class=\"bx_norecord\">");
                str.Append("<h4>" + this.NoRecordFoundText + "</h4>");
                str.Append("</div>");
                lst.InnerHtml = str.ToString();
                return;
            }
        }

        List<Tags_Struct> _list = TagsBLL.Cache_FetchRecentTags_V2(this.Term, _type, this.Tag_Type, this.Tag_Level, this.isEnabled, this.Records, this.PageNumber, this.Order, this.isCache);
        if (_list.Count > 0)
        {


            //**************************************************************
            // SCRIPT TO RUN ONLY IF PAGINATION IS ENABLED AND LOAD ALL TAGS
            //**************************************************************
            if (this.EnablePagination)
            {
                if (Config.Return_PaginationType() == 2)
                {
                    // sql server 2000 compatibility
                    this.TotalRecords = _list.Count;
                }

                // Maximum Pagination Restriction for Main Listing
                int maximum_allowed_records = Config.Get_Maximum_Pagination_Links() * this.TotalRecords;
                if (this.TotalRecords > maximum_allowed_records)
                    this.TotalRecords = maximum_allowed_records;
            }

            if (this.TotalRecords > this.Records)
            {
                pagination1.TotalRecords = this.TotalRecords;
                pagination1.PageSize = this.Records;
                pagination1.PageNumber = this.PageNumber;
                pagination1.Default_Url = this.DefaultUrl;
                pagination1.Pagination_Url = this.Pagination_Url;
                pagination1.BindPagination();

                Set_Pagination_Page_Title();
                pg.Visible = true;
            }
            //**************************************************************
            // SCRIPT TO RUN ONLY IF PAGINATION IS ENABLED AND LOAD ALL TAGS
            //**************************************************************
            UGeneral ug = new UGeneral();
            int i = 0;
            str.Append("<div class=\"bx_br_bt item_pad_4\">\n");
            if (this.MultiColumn)
            {
                // Multi Column Display
                int total_column_records = Convert.ToInt32(Math.Floor((double)_list.Count / this.TotalColumns));
                int counter = 0;
                int sectionwidth = 30;
                if (this.TotalColumns == 2)
                    sectionwidth = 49;
                else if (this.TotalColumns == 4)
                    sectionwidth = 24;
                else if (this.TotalColumns == 1)
                    sectionwidth = 100;
                str.Append("<div class=\"" + this.ListingCssClass + "\" style=\"float: left; width:" + sectionwidth + "%;\"><ul>\n");
                for (i = 0; i <= _list.Count - 1; i++)
                {
                    if(this.URL !="")
                        str.Append("<li><a href=\"" + Parse_TAGUrl_URL(this.URL, _list[i].TagName, _list[i].Term) + "\" alt=\"" + _list[i].TagName + " " + this.LinkToolTip + "\">" + _list[i].TagName + "</a></li>\n");
                    else
                        str.Append("<li>" + ug.Generate_Tag_Item(_list[i].TagName, _list[i].Records, this.Type, this.CssClass, this.MainProfileTag) + " </li>");
                    counter++;
                    if (counter >= total_column_records)
                    {
                        str.Append("</ul></div>\n");
                        str.Append("<div class=\"" + this.ListingCssClass + "\" style=\"float: left; width: " + sectionwidth + "%;\"><ul>\n");
                        counter = 0;
                    }

                }
                str.Append("</ul></div>\n");
            }
            else
            {
                // flow layout
                str.Append("<div class=\"" + this.ListingCssClass + "\"><ul>\n");
                for (i = 0; i <= _list.Count - 1; i++)
                {
                    if (this.URL != "")
                        str.Append("<li><a href=\"" + Parse_TAGUrl_URL(this.URL, _list[i].TagName, _list[i].Term) + "\" alt=\"" + _list[i].TagName + " " + this.LinkToolTip + "\">" + _list[i].TagName + "</a></li>\n");
                    else
                        str.Append("<li>" + ug.Generate_Tag_Item(_list[i].TagName, _list[i].Records, this.Type, this.CssClass, this.MainProfileTag) + " </li>");
                }
                str.Append("</ul></div>\n");
            }
            str.Append("<div class=\"clear\"></div>\n");
            str.Append("</div>\n");
            if (!this.isAll && this.MoreLinkUrl != "" && !this.EnablePagination)
            {
                // generate more link
                str.Append("<div class=\"item_pad_4_r\"><a href=\"" + Config.GetUrl(this.MoreLinkUrl) + "\" class=\"" + this.CssClass + "\" title=\"" + this.MoreLinkToolTip + "\">" + this.MoreLinkText + "</a></div>");
            }

            lst.InnerHtml = str.ToString();
            lst.Attributes.Add("class", this.BodyCssClass + " ui-helper-clearfix");
        }
        else
        {
            widget.Visible = false;
        }
    }

    private string Generate_Top_Navigation()
    {
        StringBuilder str = new StringBuilder();
        string nav_param = "term=" + this.Term + "&tagtype=" + this.Tag_Type + "&taglevel=" + this.Tag_Level + "&multicolumn=" + this.MultiColumn + "&epage=" + this.EnablePagination + "&isenabled=" + this.isEnabled + "&records=" + this.Records + "&pagenumber=1&totalpages=1&sallurl=" + this.MoreLinkUrl + "&sallt=" + this.MoreLinkText + "&salltool=" + this.MoreLinkToolTip + "&tcolumns=" + this.TotalColumns + "&cnt=" + lst.ClientID + "&&enablenav=" + this.EnableNavigation + "&navcss=" + this.NavigationCssClass + "&navactivecss=" + this.NavigationActiveLinkCssClass + "&enableanim=" + this.EnableAnimation + "&navlinkcss=" + this.NavigationLinkCssClass + "&iscache=" + this.isCache + "&lcss=" + this.ListingCssClass + "&css=" + CssClass + "&url=" + this.URL;
        nav_param = nav_param + "" + Generate_Nav_Query();
        string ajax_function_name = "Process_Req_Animate";
        if (!this.EnableAnimation)
            ajax_function_name = "Process_Req";

        if (this.NavigationLinks.Length > 0 && this.NavigationLinkOrderFields.Length > 0)
        {
            string nav_ajax_event = "";
            string nav_active_css = "";
            int i = 0;
            str.Append("<div class=\"nmtabs\">\n");
            string navcss = "";
            if (this.NavigationCssClass != "")
                navcss = " class=\"" + NavigationCssClass + "\"";
            str.Append("<ul" + navcss + ">");
            for (i = 0; i <= this.NavigationLinks.Length - 1; i++)
            {
                nav_ajax_event = ajax_function_name + "('" + handler_path + "','" + nav_param + "&type=" + this.NavigationLinkOrderFields[i].ToString() + "&tab=" + i + "','#" + lst.ClientID + "','POST','');";
                if (this.NavigationActiveTab == i)
                    nav_active_css = " class=\"" + this.NavigationActiveLinkCssClass + "\"";
                else
                    nav_active_css = "";

                string linkcss = "";
                if (this.NavigationLinkCssClass != "")
                    linkcss = " class=\"" + this.NavigationCssClass + "\"";
                str.Append("<li " + nav_active_css + "><a" + linkcss + " href=\"#\" onclick=\"" + nav_ajax_event + "\">" + this.NavigationLinks[i].ToString() + "</a></li>\n");

            }
            str.Append("</ul>");
            str.Append("<div class=\"clear\"></div>\n");
            str.Append("</div>\n");
        }

        return str.ToString();
    }

    // Generate query string for nav linkgs and nav order links array list
    private string Generate_Nav_Query()
    {
        return "&navarr=" + string.Join(",", this.NavigationLinks) + "&navarrorder=" + string.Join(",", this.NavigationLinkOrderFields);
    }

    private void PrepareBoxTemplates()
    {
        this.BoxCssClass = UGeneral.Return_Box_Css(this.BoxTemplate);
        this.HeadingCssClass = UGeneral.Return_Heading_Css(this.BoxTemplate);
    }

    private void Set_Pagination_Page_Title()
    {
        string _title = "";
        if (this.PageNumber > 1)
            _title = this.HeadingTitle + " - Page: " + this.PageNumber;
        else
            _title = this.HeadingTitle;

        string thumb_url = UrlConfig.Return_Website_Logo_Url();

        htitle.InnerHtml = _title;
        if (this.Pagination_Url != "")
        {
            string meta_title = _title;
            string meta_description = this.PageDescription;
            if (PageNumber > 1)
                meta_description = meta_description + ", Page: " + PageNumber;
            MetaTagsBLL.META_StaticPage(this.Page, (HtmlHead)Page.Header, meta_title, meta_description, thumb_url, Config.GetUrl(this.DefaultUrl));
        }

    }

    // replace [CN] with term or categoryname, [CID] with categoryid
    public string Parse_TAGUrl_URL(string input, string categoryname, string term)
    {
        if (term == "")
            term = categoryname;

        return System.Text.RegularExpressions.Regex.Replace(input, @"\[CN\]", UtilityBLL.ReplaceSpaceWithHyphin_v2(term.Trim().ToLower()));
    }

}
