﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Collections.Generic;
using System.Text;
using Google.GData.Client;
using Google.GData.Extensions;
using Google.GData.YouTube;
using Google.GData.Extensions.MediaRss;
using Google.YouTube;
using System.Text.RegularExpressions;
using System.Collections;

public partial class videos_modules_embed : System.Web.UI.UserControl
{
    YouTubeRequestSettings settings = null;
    YouTubeRequest req = null;

    public int MediaType = 0; // 0: video, 1: audio
    public int CategoryType = 5; // for photos
    public int TagType = 2; // for photos
    public string HeaderTitle = "Upload Embed Video";
    //public string AlumPath = "galleries";
    //public string UploadPath = "photos";
    public int Mode = 0; // Filter records to display in specific sections e.g Car Videos --/ Brands, Vehicle Types, Vehicle Style, Auto Shows, Enthusiast etc
    public int Response_VideoID = 0;

    public string UserName
    {
        get
        {
            if (ViewState["UserName"] != null)
                return ViewState["UserName"].ToString();
            else
                return "";
        }
        set
        {
            ViewState["UserName"] = value;
        }
    }

    public long GalleryID
    {
        get
        {
            if (ViewState["GalleryID"] != null)
                return (long)ViewState["GalleryID"];
            else
                return 0;
        }
        set
        {
            ViewState["GalleryID"] = value;
        }
    }

    public bool isAdmin
    {
        get
        {
            if (ViewState["isAdmin"] != null)
                return (bool)ViewState["isAdmin"];
            else
                return false;
        }
        set
        {
            ViewState["isAdmin"] = value;
        }
    }

    public string YoutubeID
    {
        get
        {
            if (ViewState["YoutubeID"] != null)
                return ViewState["YoutubeID"].ToString();
            else
                return "";
        }
        set
        {
            ViewState["YoutubeID"] = value;
        }
    }
    public string Duration
    {
        get
        {
            if (ViewState["Duration"] != null)
                return ViewState["Duration"].ToString();
            else
                return "";
        }
        set
        {
            ViewState["Duration"] = value;
        }
    }

    public long GroupID
    {
        get
        {
            if (ViewState["GroupID"] != null)
                return (long)ViewState["GroupID"];
            else
                return 0;
        }
        set
        {
            ViewState["GroupID"] = value;
        }
    }

    public bool GroupMember = false;
    public bool GroupAdmin = false;
    public bool GroupOwner = false;
    public int GroupPermission = 0;
    public int ContentStatus = 0; // adding content to group

    protected void Page_Load(object sender, EventArgs e)
    {
        // globalization text
        tpreview.Visible = false;
        txt_tags.Attributes.Add("placeholder", Resources.vsk.tags_message_01);
        btn_update.Text = Resources.vsk.submit; // Submit

        if (!Page.IsPostBack)
        {        

            if (Site_Settings.Feature_Uploads == 0 && !this.isAdmin)
            {
                Config.ShowMessageV2(msg, "User Can't Upload Videos", "Verification Error", 0);
                main.Visible = false;
                return;
            }

            if (Request.Params["gd"] != null)
            {
                this.GroupID = Convert.ToInt64(Request.Params["gd"]);
            }

            if (this.MediaType == 1)
            {
                // audio file
                // disable youtube fetch video section
                fytpanel.Visible = false;
            }
            cmt.InnerHtml = this.HeaderTitle;

            // load parent / child categories
            if (Site_Settings.AllowMultipleCategoryListing)
            {
                // Multiple category selection is on
                CategoriesBLL.BindCategories(l_category, 0, this.CategoryType, " " + Resources.vsk.selectcategory + " ", " ", false);
                scat.Visible = false;
            }
            else
            {
                // Single category selection is on
                // load parent / child categories
                CategoriesBLL.BindCategories(drp_category, 0, this.CategoryType, " " + Resources.vsk.selectcategory + " ", " ", false);
                mcat.Visible = false;
            }

        }
    }

    protected void btn_post_Click(object sender, EventArgs e)
    {
        // validate tags
        if (!TagsBLL.Validate_Tags(txt_tags.Text))
        {
            Config.ShowMessageV2(msg, Resources.vsk.message_groups_15, "Error!", 0); // "Problem exist in tag, please fix and post again."
            return;
        }

        if (UtilityBLL.isLongWordExist(txt_title.Text) || UtilityBLL.isLongWordExist(txt_title.Text))
        {
            Config.ShowMessageV2(msg, Resources.vsk.message_04, "Error!", 0); // "Long or bad word exist either in title or description, correct and post again"
            return;
        }

        // check for permission
        Url_Validation _url = new Url_Validation();
        int status = _url.Validate_Image_Url(txt_thumbnail.Text);

        if (status != 0)
        {
            Config.ShowMessageV2(msg, "Embed video thumbnail is not validated, please make sure you provide proper jpg image url", "Verification!", 0);
            return;
        }

        

        // Video Processing
        string flv_filename = "";
        string original_filename = "";
        string thumb_filename = "";
        string duration = this.Duration;
        int duration_sec = 0;

        // set video actions : 1 -> on, 0 -> off
        int isenabled = 1;
        int ispublished = 1;
        int isreviewed = 1;
        int isprivate = 0;
        int isresponse = 0;

        string flv_url = "none";
        string thumb_url = txt_thumbnail.Text;
        string _embed = txt_embed.Text;

        int privacy = Convert.ToInt32(drp_privacy.SelectedValue);
      
        if (!Config.isAutomativeApproval())
            isreviewed = 0;

        string ipaddress = Request.ServerVariables["REMOTE_ADDR"].ToString();
        // process categories
        string _categories = "";
        // categories enabled
        if (Site_Settings.AllowMultipleCategoryListing)
        {
            _categories = UGeneral.ReturnSelectedCategories(l_category);
            if (_categories == "")
            {
                Config.ShowMessageV2(msg, "Please select atleast one category", "Info!", 2);
                return;
            }
        }
        else
        {
            _categories = drp_category.SelectedValue;
        }
        Video_Struct vd = new Video_Struct();
        vd.CategoryID = 0; // store categoryname or term instead of category id
        vd.Categories = _categories;
        vd.UserName = this.UserName;
        vd.Title = txt_title.Text;
        vd.Description = txt_description.Text;
        vd.Tags = txt_tags.Text;
        vd.Duration = duration;
        vd.Duration_Sec = duration_sec;
        vd.OriginalVideoFileName = original_filename;
        vd.VideoFileName = flv_filename;
        vd.ThumbFileName = thumb_filename;
        vd.isPrivate = isprivate;
        vd.isEnabled = isenabled;
        vd.Response_VideoID = this.Response_VideoID;
        vd.isResponse = isresponse;
        vd.isPublished = ispublished;
        vd.isReviewed = isreviewed;
        vd.FLV_Url = flv_url;
        vd.Thumb_Url = thumb_url;
        vd.Embed_Script = _embed;
        vd.isExternal = 1; // embed video type
        vd.IPAddress = ipaddress;
        vd.Type = this.MediaType;
        vd.YoutubeID = this.YoutubeID;
        vd.isTagsreViewed = 1;
        vd.Mode = this.Mode;
        vd.GalleryID = this.GalleryID;
        vd.VideoID =  VideoBLL.Process_Info(vd, false);

        // Process video tags
        int tag_type = 0; // represent videos
        TagsBLL.Process_Tags(txt_tags.Text, tag_type, 0);

        // To Generate Video or Audio Preview for group or user activity posting
        VideoItem itm = new VideoItem();
        itm.Width = 130;
        itm.Height = 72;
        itm.ShowViews = false;
        itm.ShowDate = false;
        itm.ShowAuthor = false;
        itm.ShowDescription = false;
        itm.ShowTags = false;
        itm.ShowCategories = false;
        itm.BoxSpace = 5;
        itm.ContentLayout = 1;
        itm.BoxWidth = 0;
        itm.LeftWidth = 27;
        itm.RightWidth = 72;
        itm.ShowTitle = true;
        itm.TitleLength = 0;
        itm.ShowDescription = true;
        itm.DescriptionLength = 100;
        itm.NormalTextCssClass = "normal-text light";
        if (this.MediaType == 1)
            itm.Type = 1;
        StringBuilder pstr = new StringBuilder();
        pstr.Append(itm.Process(vd));
       

        // Generate User Activity
        //******************************************************************************
        string _username = this.UserName;
        string _usr_link = "<a class=\"bold\" href=\"" + UrlConfig.Prepare_User_Profile_Url(_username, this.isAdmin) + "\"  title=\"" + _username + "\">" + _username + "</a>";
        StringBuilder gstr = new StringBuilder();
        gstr.Append("<div class=\"item_pad_2\">\n");
        gstr.Append(pstr.ToString());
        gstr.Append("<div class=\"clear\"></div>\n");
        gstr.Append("</div>\n");

        string _mtype = "video";
        if (this.MediaType == 1)
            _mtype = "audio";
        string _title = "uploaded 1 " + _mtype;
        UserActivity_Struct ustr = new UserActivity_Struct();
        ustr.UserName = _username;
        ustr.Title = _title;
        ustr.Activity = gstr.ToString(); // generate video or audio preview item
        ActivityBLL.Add(ustr);

       
        // if video response
        if (this.Response_VideoID > 0)
        {
            // update video responses
            VideoBLL.Update_Responses(this.Response_VideoID);
        }
        if(this.isAdmin)
        {
            if (this.MediaType == 1)
                Response.Redirect(Config.GetUrl("adm/sc/videos/?status=uploaded"), true);
            else
                Response.Redirect(Config.GetUrl("adm/sc/videos/?status=uploaded&mdp=1"), true);
        }
        else
        {
            if(this.MediaType==0)
                Response.Redirect(Config.GetUrl("myaccount/myvideos.aspx?status=uploaded"), true);
            else
                Response.Redirect(Config.GetUrl("myaccount/audio/?status=uploaded"), true);
        }
   }

    private void MailTemplateProcess(string ownerusername, string username, int totalphotos, string inboxurl)
    {
        //if sending mail option enabled
        if (Config.isEmailEnabled())
        {
            System.Collections.Generic.List<Struct_MailTemplates> lst = MailTemplateBLL.Get_Record("GRPVDPST");
            if (lst.Count > 0)
            {
                string subject = MailProcess.Process2(lst[0].Subject, "\\[ownerusername\\]", ownerusername);
                subject = MailProcess.Process2(subject, "\\[username\\]", username);
                subject = MailProcess.Process2(subject, "\\[totalvideos\\]", totalphotos.ToString());

                string contents = MailProcess.Process2(lst[0].Contents, "\\[ownerusername\\]", ownerusername);
                contents = MailProcess.Process2(contents, "\\[username\\]", ownerusername);

                string group_url = Config.GetUrl("group/" + this.GroupID + ".aspx");
                string url = "<a href=\"" + group_url + "\">" + group_url + "</a>";

                contents = MailProcess.Process2(contents, "\\[url\\]", url);

                contents = MailProcess.Process2(contents, "\\[inboxurl\\]", inboxurl);
                contents = MailProcess.Process2(contents, "\\[totalvideos\\]", totalphotos.ToString());

                string emailaddress = members.Return_Value(ownerusername, "email");

                MailProcess.Send_Mail(emailaddress, subject, contents);
            }
        }
    }


    protected void btn_fetch_Click(object sender, EventArgs e)
    {
         string ytid = Fetch_YoutubeID(txt_fetch.Text);
         if (ytid == "")
         {
             Config.ShowMessageV2(msg, "Youtube video url failed to validate, please enter proper youtube id", "Error!", 0);
             return;
         }
         string ApplicationName = Site_Settings.Yt_Application_Name;
         string DeveloperID = Site_Settings.Yt_Developer_Key;
         settings = new YouTubeRequestSettings(ApplicationName, DeveloperID);
         req = new YouTubeRequest(settings);

         YouTubeQuery query = new YouTubeQuery("http://gdata.youtube.com/feeds/api/videos/" + ytid);
         //Feed<Video> videoFeed = req.Get<Video>(query);
         Video video = req.Retrieve<Video>(query);
         ProcessVideoEntry(video);
    }

    private string Fetch_YoutubeID(string URL)
    {
        string reg = @"(?<=v(\=|\/))(?<yid>([-a-zA-Z0-9_]+))|(?<=youtu\.be\/)(?<yid2>([-a-zA-Z0-9_]+))";
        System.Text.RegularExpressions.Match VDMatch = System.Text.RegularExpressions.Regex.Match(URL, reg);
        if (VDMatch.Success)
        {
            if (VDMatch.Groups["yid"].Value != "")
                return VDMatch.Groups["yid"].Value; // normal pattern
            else
                return VDMatch.Groups["yid2"].Value; // pattern like http://youtu.be/[id]
        }
        else
            return "";
    }

    private void ProcessVideoList(Feed<Video> feed)
    {
        foreach (Video entry in feed.Entries)
        {
            ProcessVideoEntry(entry);
        }
    }

    private void ProcessVideoEntry(Video video)
    {
        try
        {
            
            string videoid = video.Id;
            if (videoid.Contains(":"))
            {
                videoid = videoid.Remove(0, videoid.LastIndexOf(":") + 1);
            }
            string video_watch_id = "/watch?v=" + videoid;
            txt_title.Text = video.Title;
            txt_description.Text = video.Description;
         
            string tag_list = video.Keywords;
            ArrayList thumb_urls = new ArrayList();
            foreach (MediaThumbnail thumbnail in video.Thumbnails)
            {
                thumb_urls.Add(thumbnail.Url);
                // str.Append("\tThumbnail URL: " + thumbnail.Url + "<br />");
                // str.Append("\tThumbnail time index: " + thumbnail.Time + "<br />");
            }
            if (thumb_urls.Count > 1)
            {
                int count = Convert.ToInt32(thumb_urls.Count / 2);
                txt_thumbnail.Text = thumb_urls[count].ToString();
            }
            else
            {
                txt_thumbnail.Text = thumb_urls[0].ToString();
            }

            if (txt_thumbnail.Text.Length>0)
            {
                tpreview.Visible = true;
                ytpreview.Src = txt_thumbnail.Text;
                thumburl.Visible = false;
            }
            foreach (Google.GData.YouTube.MediaContent mediaContent in video.Contents)
            {
               // str.Append("\tMedia Location: " + mediaContent.Url + "<br />");
               // str.Append("\tMedia Type: " + mediaContent.Format + "<br />");
               this.Duration = mediaContent.Duration;
            }
            //string _tags = tag_list.ToString();
            //if (_tags.Length > 200)
            //    _tags = _tags.Substring(0, 200);
            //txt_tags.Text = _tags;
           
            this.YoutubeID = video_watch_id;

            txt_embed.Visible = false; // embed is not required, only youtube video id is enough
        }
        catch (Exception ex)
        {
            Config.ShowMessageV2(msg, "Error Occured: " + ex.Message, "Error", 0);
        }
    }

}