﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;

public partial class videos_search : System.Web.UI.Page
{
    protected string NavigationClass = "";
    protected string BodyClass = "";
    protected string BodyRight = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        Process_Layout();

        if (!Page.IsPostBack)
        {
            string term = "";
            if (Request.Params["query"] != null)
            {
                term = UtilityBLL.CleanSearchTerm(Server.UrlDecode(Request.Params["query"].ToString()).Trim());
                if (Request.Params["cat"] != null)
                    term = term + ", " + Server.UrlDecode(Request.Params["cat"].ToString()); // append select categories with search
                lst1.SearchType = 3; // broad search
            }
            else if (Request.Params["cat"] != null)
            {
                term = Server.UrlDecode(Request.Params["cat"].ToString()); // append select categories with search
                lst1.SearchType = 0; // category match only
            }
            lst1.Term = term;
            if (Request.Params["usr"] != null)
                lst1.UserName = Request.Params["usr"].ToString();
            if (Request.Params["tp"] != null)
                lst1.isFeatured = Convert.ToInt32(Request.Params["tp"]);

            if (Request.Params["o"] != null)
            {
                switch (Request.Params["o"].ToString())
                {
                    case "0":
                        lst1.Order = "v.date_added desc, v.liked asc";
                        break;
                    case "1":
                        lst1.Order = "v.title asc, v.liked asc";
                        break;
                    case "2":
                        lst1.Order = "v.liked desc, v.date_added desc";
                        break;
                    case "3":
                        lst1.Order = "v.comments desc, v.date_added desc";
                        break;
                }
            }
            else
                lst1.Order = "v.date_added desc, v.liked desc,v.views desc";

            lst1.isListStatus = true;
            lst1.isListNav = false;


            lst1.isCache = false; // load and cache records
            lst1.PageSize = Site_Settings.Video_Page_Size;

            lst1.PageDescription = "list of videos based on normal or advance search results";

            // lst pagination

            // generate pagination link if advance search selected
            if (Request.Params["o"] != null)
            {
                StringBuilder str = new StringBuilder();
                str.Append("?o=" + lst1.Order);
                if (Request.Params["query"] != null)
                    str.Append("&query=" + Request.Params["query"].ToString());
                if (Request.Params["usr"] != "")
                    str.Append("&usr=" + Request.Params["usr"]);
                if (Request.Params["cat"] != "")
                    str.Append("&cat=" + Request.Params["cat"]);
                if (Request.Params["tp"] != "")
                    str.Append("&tp=" + Request.Params["tp"]);

                lst1.DefaultUrl = "videos/search.aspx?" + str.ToString();
                lst1.Pagination_Url = "videos/search.aspx?" + str.ToString() + "&p=[p]";
            }
            else
            {
                // normal search
                lst1.DefaultUrl = "videos/search.aspx?" + Request.Params["query"].ToString();
                lst1.Pagination_Url = "videos/search.aspx?query=" + Request.Params["query"].ToString() + "&p=[p]";
            }

            lst1.PageTitle = "Search Result";
            lst1.NoRecordFoundText = "No Videos found with your selected search";


            set_bread_links();
        }
    }

    private void set_bread_links()
    {
        string _rooturl = Config.GetUrl();
        StringBuilder str = new StringBuilder();
        str.Append("<li><a href=\"" + _rooturl + "\">" + Resources.vsk.home + "</a><span class=\"divider\">/</span> </li>\n");
        str.Append("<li><a href=\"" + _rooturl + "videos/\">" + Resources.vsk.videos + "</a><span class=\"divider\">/</span> </li>\n");
        str.Append("<li class=\"active\">Search Result</li>\n");
        bread.InnerHtml = str.ToString();
    }

    // Core script to handle website layout
    private void Process_Layout()
    {
        UGeneral ug = new UGeneral();
        int selected_layout_option = Site_Settings.NavigationSection;
        if (selected_layout_option == 2)
        {
            // three column layout
            navigation1.Visible = false; // advance navigation disable
            navigation_sm1.Visible = true; // first column simple navigation
            third_nav1.Visible = true; // third column navigation
        }
        else
        {
            // two column layout
            navigation1.Visible = true;
            navigation_sm1.Visible = false;
            third_nav1.Visible = false;

        }

        NavigationClass = ug.Return_Navigation_Class();
        BodyClass = ug.Return_Body_Class();
        BodyRight = ug.Return_RightNav_Class();

    }
}