﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;

public partial class videos_tag_Default : System.Web.UI.Page
{
    protected string NavigationClass = "";
    protected string BodyClass = "";
    protected string BodyRight = "";
    protected string CanonicalLink = "";
    protected void Page_Load(object sender, EventArgs e)
    {
        Process_Layout();
        if (!Page.IsPostBack)
        {
            if (Site_Settings.NavigationSection == 1)
            {
                // right side navigation
                NavigationClass = "chnl_right_nav";
                BodyClass = "chnl_left_mn";
            }

            if (Request.Params["query"] != null && Request.Params["query"] != "")
            {
                string tagname = UtilityBLL.UppercaseFirst(UtilityBLL.ReplaceHyphinWithSpace(Request.Params["query"].ToString().Trim()), true);
                lst1.isListStatus = true;

                lst1.Term = tagname;
                lst1.SearchType = 1;
                lst1.PageTitle = Resources.vsk.videos_tag_title.Replace("[term]", tagname); // tagname + " Videos";

                lst1.PageDescription = Resources.vsk.videos_tag_desc.Replace("[term]", tagname); // "Browse best " + tagname.ToLower() + " videos";
                lst1.NoRecordFoundText = Resources.vsk.videos_tag_notfound.Replace("[term]", tagname); // "No " + tagname + " Videos Found!";
                lst1.isFeatured = 2; // load both featured and normal videos
                lst1.isAudio = 0; // load only videos
                lst1.isPrivate = 0; // load only public videos
                lst1.Order = "v.date_added desc, v.liked desc, v.views desc";
                lst1.isCache = false;
                lst1.PageSize = Site_Settings.Video_Page_Size;
              
                lst1.isListNav = false;
                // pagination urls
                lst1.DefaultUrl = "videos/tag/" + Request.Params["query"].ToString() + ".aspx";
                lst1.Pagination_Url = "videos/tag/" + Request.Params["query"].ToString() + "/[p].aspx";
               
                CanonicalLink = Config.GetUrl(lst1.DefaultUrl);

                set_bread_links(tagname);
            }
            else
            {
                Response.Redirect(Config.GetUrl("videos/"));
            }

        }

    }

    private void set_bread_links(string title)
    {
        string _rooturl = Config.GetUrl();
        StringBuilder str = new StringBuilder();
        str.Append("<li><a href=\"" + _rooturl + "\">" + Resources.vsk.home + "</a><span class=\"divider\">/</span> </li>\n");
        str.Append("<li><a href=\"" + _rooturl + "videos/\">Videos</a><span class=\"divider\">/</span> </li>\n");
        str.Append("<li><a href=\"" + _rooturl + "videos/tags.aspx\">Tags</a><span class=\"divider\">/</span> </li>\n");
        str.Append("<li class=\"active\">" + title + "</li>\n");
        bread.InnerHtml = str.ToString();
    }

    // Core script to handle website layout
    private void Process_Layout()
    {
        UGeneral ug = new UGeneral();
        int selected_layout_option = Site_Settings.NavigationSection;
        if (selected_layout_option == 2)
        {
            // three column layout
            navigation1.Visible = false; // advance navigation disable
            navigation_sm1.Visible = true; // first column simple navigation
            third_nav1.Visible = true; // third column navigation
        }
        else
        {
            // two column layout
            navigation1.Visible = true;
            navigation_sm1.Visible = false;
            third_nav1.Visible = false;

        }

        NavigationClass = ug.Return_Navigation_Class();
        BodyClass = ug.Return_Body_Class();
        BodyRight = ug.Return_RightNav_Class();

    }
   
}